<?php

defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');

/**
 * An Joomla Based Filesystem class
 * 
 * @access public
 */
class JoomlaPlatform extends zoom {

    function JoomlaPlatform() {
        //empty constructor
    }
    
    function copy($source, $dest) {
    	return JFile::copy($source,$dest);
    }

    function upload($source, $dest) {
    	return JFile::upload($source,$dest);
    }

    function exec($cmd, &$results, &$status, $debugfile="") {
    	if (!empty($debugfile)) {
    		$cmd = "($cmd) 2>$debugfile";
    	} 
    	return exec($cmd, $results, $status);
    }
    
/* This is not used
    function tempdir() {
    	return $this->export_filename(getenv("TEMP"));
    }
*/ 

    function file_exists($filename) {
    	return JFile::exists($filename);
    }
/*
    function is_link($filename) {
    	return @is_link($filename);
    }
*/

    function filesize($filename) {
    	return filesize($filename);
    }

    function getimagesize($filename) {
        return getimagesize($filename);
    }
    
    function is_dir($filename) {
    	return @is_dir($filename);
    }
 
    function is_file($filename) {
    	return @is_file($filename);
    }

    function opendir($path) {
    	return opendir($path);
    }

    function closedir($dir_handle) {
        return closedir($dir_handle);
    }
    
    function chdir($path) {
        return chdir($path);
    }
    
    function readdir($dir_handle) {
        return readdir($dir_handle);
    }
    
    function rename($oldname, $newname) {
    	return JFolder::move($oldname, $newname);
    }
    
    function stat($filename) {
    	return stat($filename);
    }
    
    function unlink($filename) {
    	return JFile::delete($filename);
    }

    function is_executable($filename) {
	if (function_exists('is_executable')) {
    		return is_executable($filename);
	} else {
		return eregi(".(exe|com)$", $filename);
	}
    }

    function import_filename($filename) {
    	return $filename;
    }
    
    function export_filename($filename) {
	if ( JPATH_ISWIN ) {
		# Convert "d:\winnt\temp" to "d:/winnt/temp"
		#
		while (strstr($filename, "\\\\")) {
			$filename = str_replace("\\\\", "\\", $filename);
		}
		$filename = str_replace("\\", "/", $filename);
	}
    	return $filename;
    }
/*
    function executable($filename) {
    	return $filename;
    }
*/
    
    function mkdir($filename, $perms = '0666') {
    	$perms = octdec($perms);
	return JFolder::create($filename,$perms);
    }
    
    function rmdir($path) {
        return JFolder::delete($path);
    }
    
    /**
     * Chmods files and directories recursively to given permissions. Available from 1.0.0 up.
     * @param $path The starting file or directory (no trailing slash)
     * @param $perms Integer value to chmod files. NULL = dont chmod files.
     * @return TRUE=all succeeded FALSE=one or more chmods failed
     */
    function chmod($path, $perms = 0644) {
	if ( JPATH_ISWIN ) {
		return true; //there's no need to CHMOD files in Windows based environments.
	}
        $ret = TRUE;
    	if (is_dir($path)) {
    		$dh = opendir($path);
    		while ($file = readdir($dh)) {
    			if ($file != '.' && $file != '..') {
    				$fullpath = $path.'/'.$file;
    				if (is_dir($fullpath)) {
    					if (!$this->chmod($fullpath, $perms))
    						$ret = FALSE;
    				} else {
    					if (isset($perms))
    						if (!@chmod($fullpath, $perms))
    							$ret = FALSE;
    				} // if
    			} // if
    		} // while
    		closedir($dh);
    		if (!@chmod($path, $perms))
    			$ret = FALSE;
    	} else {
    		if (isset($perms))
    			$ret = @chmod($path, $perms);
    	} // if
    	return $ret;
    }
	
	function files ( $path, $filter = '.', $recurse = false, $fullpath = false, $exclude = array('.svn', 'CVS')) {
		 return JFolder::files( $path, $filter, $recurse, $fullpath, $exclude);
	}

    /**
     * @see platform::splitPath
     */
    function splitPath($path) {
	if ( JPATH_ISWIN ) {
		$list = array();
		if (preg_match('|^([A-Za-z]:)?[\\\/]|', $path, $match)) {
			$list[] = $match[0];
			$path = substr($path, strlen($match[0]));
		}
		foreach (preg_split('|[\\\/]|', $path) as $element) {
			if (!empty($element)) {
	 			$list[] = $element;
			}
		}
	} else {
    		$slash = $this->getDirectorySeparator();
    		$list = array();
    		foreach (explode($slash, $path) as $element) {
    	    	if (!empty($element)) {
    		  	$list[] = $element;
    	    	} else if (empty($list)) {
    		  	$list[] = $slash;
    	    	}
    		}
    	}
    	return $list;
    }

    /**
     * @see platform::isSymlinkSupported
     */
    function isSymlinkSupported() {
	   return (!JPATH_ISWIN);
    }

    function write($filename,$buffer) {
	return JFile::write($filename,$buffer);
    }

    function read($filename) {
	return JFile::read($filename);
    }
}
