<?php

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

require_once (JPATH_COMPONENT.DS.'view.php');

/**
 * HTML Zoom View class for the ZMG component
 *
 * @package             zOOmGallery
 * @subpackage  zOOmGallery
 * @since 1.5
 */
class ZoomViewSpecial extends ZoomView
{

	function display($tpl = null)
	{
		global $zoom,$mainframe;

		$sorting = JRequest::getInt('sorting',0);
		$methods = array(
			0 => 'MostPopular',
			1 => 'LastSubmitted',
			2 => 'LastCommented',
			4 => 'TopRated'
		);

		if (empty($methods[$sorting])){
			JError::raiseError(404,'Invalid sorting method');
			return false;
		}
		$method = $methods[$sorting];

		$items = $this->get($method);

		if ($zoom->_CONFIG['ratingOn']) {
		    $zoom->createRatingCSS();
		}

		$title = JText::_('TOPTEN');
		if( $sorting == 1 ) $title = JText::_('LASTSUBM');
		else if( $sorting == 2 ) $title =JText::_('LASTCOMM');
		else if( $sorting == 4 ) $title =JText::_('TOPRATED');

		$mainframe->setPageTitle($title);

		$this->assignRef('zoom',   $zoom);
		$this->assignRef('title',  $title);
		$this->assignRef('items',  $items);
		$this->assignRef('params', $params);

		parent::display($tpl);
	}
}
